open PCP;;

let get_dictionaries args =
 match List.fold_left (^) "" args with  (* if more args passed *)
   | "-" -> (*read from stdin*)
     read_line ()
   | ds -> (*read parameters*)
     ds
;;

let main solve =
 let cmd::args= Array.to_list Sys.argv in
 if args = [] then (
  Format.printf "Usage: %s \"<dict1> <dict2>\"\n" cmd;
  Format.printf "e.g. %s \"[0;01;110] [100;00;11]\"\n" cmd;
  exit 0;
 ) else
  let ds = get_dictionaries args in
  match solve (PCP.PCPParser.parse ds) with
   | None -> Format.printf "false\n"
   | Some is -> 
     Format.printf "true\n";
     List.iter (Format.printf "%d ") is;
     Format.printf "\n";
;;

(* improve this function *)
let solve ds = if PCP.solve ds then Some [] else None;;

(* main solve;; *)

(* E13 *)
let solve ds = PCP.solve_dpsq ds;;

main solve;;

